ALTER VIEW [dbo].[PMX_MOVIANTO_SSCC_SHIPPING_LABEL]
AS
SELECT     dbo.PMX_LUID.SSCC, dbo.PMX_PLHE.ShipToAddress, ISNULL(dbo.ORDR.CardName, dbo.OINV.CardName) AS ShipTo, dbo.OITM.ItemName AS ProductDescription, 
                      dbo.PMX_MVLI.Quantity, dbo.OITM.CodeBars AS Barcode, dbo.PMX_ITRI.BatchNumber, dbo.PMX_ITRI.BestBeforeDate, dbo.PMX_PLHE.DueDate AS DepartureDate, 
                      dbo.PMX_LUID.InternalKey AS LUID, dbo.PMX_LUID.LogisticCarrierCode, dbo.PMX_MVLI.ItemCode, ISNULL(dbo.OITM.U_PMX_LOCA, 'N') AS IsLogisticCarrier, 
                      dbo.PMX_LUID.Weight, dbo.PMX_LUID.WeightUom, dbo.PMX_LUID.Length, dbo.PMX_LUID.LengthUom, dbo.PMX_LUID.Width, dbo.PMX_LUID.WidthUom, 
                      dbo.PMX_LUID.Height, dbo.PMX_LUID.HeightUom, dbo.ORDR.U_PMX_DR_NAM2, dbo.ORDR.Address2, dbo.ORDR.U_PMX_MOV_TXT06, dbo.ORDR.NumAtCard, 
                      dbo.ORDR.U_PMX_DR_IMSC, dbo.ORDR.U_PMX_DR_IMSN, dbo.PMX_PLHE.DocEntry AS PickListDocEntry
FROM         dbo.PMX_LPLM INNER JOIN
                      dbo.PMX_PLLI INNER JOIN
                      dbo.PMX_PLHE ON dbo.PMX_PLLI.DocEntry = dbo.PMX_PLHE.DocEntry ON dbo.PMX_LPLM.PickListDocEntry = dbo.PMX_PLHE.DocEntry AND 
                      dbo.PMX_LPLM.PickListLineNum = dbo.PMX_PLLI.LineNum AND dbo.PMX_PLLI.LineStatus = 'O' INNER JOIN
                      dbo.OITM INNER JOIN
                      dbo.PMX_LUID INNER JOIN
                      dbo.PMX_MVLI ON dbo.PMX_LUID.InternalKey = dbo.PMX_MVLI.DestLogUnitIdentKey ON dbo.OITM.ItemCode = dbo.PMX_MVLI.ItemCode ON 
                      dbo.PMX_LPLM.MoveDocEntry = dbo.PMX_MVLI.DocEntry AND dbo.PMX_LPLM.MoveLineNum = dbo.PMX_MVLI.LineNum INNER JOIN
                      dbo.PMX_PLPL ON dbo.PMX_PLPL.DocEntry = dbo.PMX_PLLI.BaseEntry AND dbo.PMX_PLPL.LineNum = dbo.PMX_PLLI.BaseLine AND 
                      dbo.PMX_PLLI.BaseType = 'PMX_PLPH' LEFT OUTER JOIN
                      dbo.OINV ON dbo.PMX_PLPL.BaseType = dbo.OINV.ObjType AND dbo.PMX_PLPL.BaseEntry = dbo.OINV.DocEntry LEFT OUTER JOIN
                      dbo.ORDR ON dbo.ORDR.DocEntry = dbo.PMX_PLPL.BaseEntry AND dbo.ORDR.ObjType = dbo.PMX_PLPL.BaseType LEFT OUTER JOIN
                      dbo.PMX_ITRI ON dbo.PMX_MVLI.ItemTransactionalInfoKey = dbo.PMX_ITRI.InternalKey


GO