ALTER VIEW [dbo].[PMX_MOV_PICKLIST_SER]
AS
SELECT        dbo.PMX_PLHE.DocEntry, 'NL01' AS Site, 
--dbo.PMX_PLHE.DocEntry AS WorkOrder, 
dbo.PMX_PLHE.WaveKey AS WorkOrder, 
CONVERT(varchar(50), GETDATE(), 127) AS DateTime, 
                         CASE WHEN ORDR.U_MOV_CUST_CAT = 'EXPORT' THEN 'Export' ELSE 'Dispense' END AS WorkOrderType, 'Add' AS Action, '' AS Supplement, dbo.PMX_PLLI.ItemCode AS L_SKU, 
                         dbo.PMX_PLLI.Dscription AS L_Description, dbo.PMX_ITRI.BatchNumber AS L_Batch, CONVERT(varchar(8), dbo.PMX_ITRI.BestBeforeDate, 112) AS L_ExpiryDate, dbo.OITM.CodeBars AS L_ProductCode, 
                         '' AS L_SerialNumber, dbo.PMX_PLLI.QtyPicked AS L_RequiredQuantity, dbo.ORDR.U_PMX_DR_IMSC AS L_ClientID, dbo.ORDR.NumAtCard AS L_OrderID, dbo.ORDR.U_MOV_CUST_CAT AS L_CustomerCategory, 
                         dbo.OITM.U_MOV_CHAN_VAL AS L_ChannelValidate, dbo.OITM.U_MOV_CHAN_DEC AS L_ChannelDecommission, '' AS L_Supplement
FROM            dbo.PMX_PLHE INNER JOIN
                         dbo.PMX_PLLI ON dbo.PMX_PLLI.DocEntry = dbo.PMX_PLHE.DocEntry INNER JOIN
                         dbo.PMX_PLPL ON dbo.PMX_PLLI.BaseEntry = dbo.PMX_PLPL.DocEntry AND dbo.PMX_PLLI.BaseLine = dbo.PMX_PLPL.LineNum AND dbo.PMX_PLLI.BaseType = 'PMX_PLPH' LEFT OUTER JOIN
                         dbo.RDR1 ON dbo.PMX_PLPL.BaseEntry = dbo.RDR1.DocEntry AND dbo.PMX_PLPL.BaseLine = dbo.RDR1.LineNum AND dbo.PMX_PLPL.BaseType = dbo.RDR1.ObjType LEFT OUTER JOIN
                         dbo.ORDR ON dbo.RDR1.DocEntry = dbo.ORDR.DocEntry INNER JOIN
                         dbo.OCRD ON dbo.PMX_PLHE.CardCode = dbo.OCRD.CardCode INNER JOIN
                         dbo.[@MOV_CUSTOMERCATAGOR] ON CASE WHEN (ISNULL(dbo.ORDR.U_MOV_CUST_CAT, '') <> '' AND (ISNULL(dbo.ORDR.U_MOV_CUST_CAT, '') <> ISNULL(dbo.OCRD.U_MOV_CUST_CAT, ''))) 
                         THEN dbo.ORDR.U_MOV_CUST_CAT ELSE dbo.OCRD.U_MOV_CUST_CAT END = dbo.[@MOV_CUSTOMERCATAGOR].Code INNER JOIN
                         dbo.OITM ON dbo.PMX_PLLI.ItemCode = dbo.OITM.ItemCode LEFT OUTER JOIN
                         dbo.PMX_ITRI ON dbo.PMX_PLLI.ItemTransactionalInfoKey = dbo.PMX_ITRI.InternalKey
WHERE        (dbo.PMX_PLHE.PickListStatus IN ('P', 'K')) AND (dbo.[@MOV_CUSTOMERCATAGOR].U_VerifySerialNumber = 'Y') AND (dbo.OITM.U_MOV_SERIAL = 'Y')

GO