ALTER VIEW [dbo].[PMX_MoviantoSalesOrder] AS
--VERSION 24NOV2016 - TOAN
select 	ORDR.DocEntry,
		ORDR.CardName,
		ORDR.U_PMX_MOV_TXT01,
		ORDR.U_PMX_MOV_TXT02,
		ORDR.U_PMX_MOV_TXT03,
		ORDR.U_PMX_MOV_TXT04,
		ORDR.U_PMX_MOV_TXT05,
		ORDR.U_PMX_MOV_TXT06,
		ORDR.U_PMX_MOV_TXT07,
		ORDR.U_PMX_MOV_TXT08,
		ORDR.U_PMX_MOV_TXT09,
		ORDR.U_PMX_MOV_TXT10,
		ORDR.NumAtCard,
		ORDR.DocDueDate,
		ORDR.U_CUSTOMER_PO,
		ORDR.U_PMX_DR_SAL_ORDR,
		ORDR.Comments,
		ORDR.U_PMX_DR_IMSC,
		ORDR.U_PMX_DR_NAM2,
		ORDR.U_PMX_DR_ADR2,
		ORDR.U_PMX_DR_EREM,
		ORDR.U_PMX_MOV_TXT05 AS LanguageCode,
		ORDR.TrnspCode,
		ORDR.PickRmrk,
		convert(varchar(100),RDR1.U_PMX_DR_COMMENTS) AS U_PMX_DR_COMMENTS,
		RDR1.LineNum,
		RDR1.ItemCode,
		RDR1.Quantity,
		RDR1.DiscPrcnt,
		RDR1.Price,
		CONVERT(numeric(19,6),ROUND(RDR1.Price*CASE WHEN RDR1.DiscPrcnt = 0 THEN 1 ELSE (100-RDR1.DiscPrcnt)/100 END,2))PriceAfterDiscount,
		OITM.ItemName,
		RDR1.TreeType,
		OITM.U_PMX_DG_CLASS AS Class,
		OITM.U_PMX_DG_CTRYOFORG AS CountryOfOrigin,
		OITM.U_PMX_DG_EQ AS EQ,
		OITM.U_PMX_DG_HSCODE AS HSCODE,
		OITM.U_PMX_DG_LABEL AS LABEL,
		OITM.U_PMX_DG_LIQSOL AS Liquid_Solid,
		OITM.U_PMX_DG_LQ AS LQ,
		OITM.U_PMX_DG_MSDS AS MSDS,
		OITM.U_PMX_DG_NWKVE AS NetWeightVKE,
		OITM.U_PMX_DG_NWSKU AS NetWeightSKU,
		OITM.U_PMX_DG_VOLKVE AS VolumeVKE,
		OITM.U_PMX_DG_VOLSKU AS VolumeSKU,
		OITM.U_PMX_DG_PKGGRP AS PackingGroup,
		OITM.U_PMX_DG_TXT01 AS Freetxt01,
		OITM.U_PMX_DG_TXT02 AS Freetxt02,
		OITM.U_PMX_DG_TXT03 AS Freetxt03,
		OITM.U_PMX_DG_TXT04 AS Freetxt04,
		OITM.U_PMX_DG_TXT05 AS Freetxt05,
		OITM.U_PMX_DG_TXT06 AS Freetxt06,
		RDR12.StreetS,
		RDR12.CityS,
		RDR12.ZipCodeS,
		RDR12.CountryS

		FROM ORDR 
		INNER JOIN RDR1 ON ORDR.DocEntry = RDR1.DocEntry
		INNER JOIN RDR12 ON ORDR.DocEntry = RDR12.DocEntry
		INNER JOIN OITM ON RDR1.ItemCode = OITM.ItemCode
GO