USE [MOV_BE_AALST_PRD]
GO
/****** Object:  StoredProcedure [dbo].[PMX_SP_DirkRaesProcessUpdates]    Script Date: 11/17/2014 16:49:45 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[PMX_SP_DirkRaesProcessUpdates]
	
AS
BEGIN
	SET NOCOUNT ON;

	DECLARE @key     INTEGER
	DECLARE @itriKey INTEGER

	SELECT TOP 1 @key = InternalKey, @itriKey = ItriKey
	FROM dbo.PMX_DR_OBTN_UPDATE

	WHILE @@ROWCOUNT > 0
	BEGIN
		-- BEGIN TRANSACTION

		PRINT 'ItriKey ' + CAST( @itriKey AS VARCHAR )

		UPDATE OBTN  SET U_PMX_STATUS = (
			SELECT CONVERT( VARCHAR, CONVERT( REAL, ISNULL( qty_released, 0 ) - ISNULL( qty_locked, 0 ) ) ) + ' free '
				 + CONVERT( VARCHAR, CONVERT( REAL,                             ISNULL( qty_locked, 0 ) ) ) + ' locked '
				 + CONVERT( VARCHAR, CONVERT( REAL, ISNULL( qty_other   , 0 )                           ) ) + ' other ('
				 + CONVERT( VARCHAR, GETDATE(), 120 ) + ')'
			FROM (
				SELECT SUM( CASE PMX_INVT.QualityStatusCode WHEN 'RELEASED' THEN PMX_INVT.Quantity ELSE NULL END ) AS qty_released,
					   SUM( CASE PMX_INVT.QualityStatusCode WHEN 'RELEASED' THEN NULL ELSE PMX_INVT.Quantity END ) AS qty_other
				FROM PMX_ITRI
				INNER JOIN PMX_INVT ON PMX_INVT.ItemCode = PMX_ITRI.ItemCode AND PMX_INVT.ItemTransactionalInfoKey = PMX_ITRI.InternalKey
				WHERE PMX_ITRI.ItemCode = OBTN.ItemCode AND PMX_ITRI.BatchNumber = OBTN.DistNumber
			) batch, (
				SELECT ISNULL( NULLIF( SUM( ITL1.Quantity ), 0 ), SUM( ITL1.AllocQty ) ) AS qty_locked
				FROM  ORDR 
				INNER JOIN RDR1 ON RDR1.DocEntry = ORDR.DocEntry
				INNER JOIN OITL ON OITL.DocEntry = RDR1.DocEntry AND OITL.DocLine = RDR1.LineNum AND OITL.DocType = RDR1.ObjType
				INNER JOIN ITL1 ON ITL1.LogEntry = OITL.LogEntry
				WHERE ORDR.DocStatus = 'O' AND RDR1.LineStatus = 'O'
				AND   RDR1.ItemCode = OBTN.ItemCode AND ITL1.SysNumber = OBTN.SysNumber
			) lock
		)
		FROM PMX_ITRI
		INNER JOIN OBTN ON OBTN.ItemCode = PMX_ITRI.ItemCode AND OBTN.DistNumber = PMX_ITRI.BatchNumber
		WHERE PMX_ITRI.InternalKey = @itriKey

		DELETE FROM dbo.PMX_DR_OBTN_UPDATE
		WHERE InternalKey = @key

		-- COMMIT

		SELECT TOP 1 @key = InternalKey, @itriKey = ItriKey
		FROM dbo.PMX_DR_OBTN_UPDATE
	END

END
