ALTER PROCEDURE [dbo].[PMX_SP_MOVIANTO_PickListDocumentWithSerialNumbers] 
	-- Parameters for the stored procedure
	@pickListDocEntry int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED;
	SET NOCOUNT ON;

SELECT     TOP (100) PERCENT dbo.PMX_PLHE.DocEntry,dbo.PMX_PLLI.LineNum, dbo.PMX_PLHE.CardCode, dbo.PMX_PLHE.CardName, dbo.PMX_PLHE.ShipToAddress, PMX_OSEL_1.Name AS Dock, 
                      dbo.PMX_PLHE.DueDate, dbo.PMX_PLHE.Priority, dbo.PMX_PLHE.PickPackRemarks, dbo.PMX_PLLI.ItemCode, dbo.PMX_PLLI.Dscription, dbo.PMX_PLLI.Quantity, 
                      dbo.PMX_PLLI.Uom, dbo.PMX_PLLI.QualityStatusCode, dbo.PMX_ITRI.BatchNumber, dbo.PMX_ITRI.BestBeforeDate, dbo.PMX_LUID.SSCC, 
                      dbo.PMX_OSSL.Name AS PickLocation, ISNULL(dbo.PMX_OSSL.Sequence, 1999999) AS Sequence, dbo.RDR1.FreeTxt, dbo.OSHP.TrnspName, dbo.ORDR.NumAtCard, 
                      dbo.ORDR.U_PMX_DR_IMSC AS ClientCode, dbo.PMX_PLHE.WaveKey, dbo.ORDR.U_PMX_DR_IMSN AS ClientName, dbo.PMX_ITZT.ZoneTypeCode,ORDR.U_CUSTOMER_PO,dbo.OITM.U_PMX_DR_CATEGORIE, dbo.ORDR.Comments,dbo.PMX_SENU.SerialNumber, dbo.RDR1.U_PMX_DR_Comments, dbo.oitm.U_PMX_SARM,
					  dbo.OITM.U_PMX_DG_UNCODE,
dbo.OITM.U_PMX_DG_PKGGRP,
dbo.OITM.U_PMX_DG_CLASS,
dbo.OITM.U_PMX_DG_MSDS,
dbo.OITM.U_PMX_DG_LABEL,
dbo.OITM.U_PMX_DG_CTRYOFORG,
dbo.OITM.U_PMX_DG_LQ,
dbo.OITM.U_PMX_DG_EQ,
dbo.OITM.U_PMX_DG_TXT01,
dbo.OITM.U_PMX_DG_TXT02,
dbo.OITM.U_PMX_DG_TXT03,
dbo.OITM.U_PMX_DG_TXT04,
dbo.OITM.U_PMX_DG_TXT05,
dbo.OITM.U_PMX_DG_TXT06,
dbo.OITM.U_PMX_DG_VOLKVE,
dbo.OITM.U_PMX_DG_VOLSKU,
dbo.OITM.U_PMX_DG_NWKVE,
dbo.OITM.U_PMX_DG_NWSKU,
dbo.OITM.U_PMX_DG_LIQSOL,
dbo.OITM.U_PMX_DG_HSCODE,
dbo.ORDR.U_PMX_MOV_TXT01,dbo.ORDR.U_PMX_MOV_TXT02,dbo.ORDR.U_PMX_MOV_TXT03,dbo.ORDR.U_PMX_MOV_TXT04,dbo.ORDR.U_PMX_MOV_TXT05,
dbo.ORDR.U_PMX_MOV_TXT06,dbo.ORDR.U_PMX_MOV_TXT07,dbo.ORDR.U_PMX_MOV_TXT08,dbo.ORDR.U_PMX_MOV_TXT09,dbo.ORDR.U_PMX_MOV_TXT10,
dbo.ORDR.U_PMX_DR_EREM,
					  PMX_ITRI.InternalBatchNumber AS BatchNumber2
FROM         dbo.PMX_PLHE INNER JOIN
                      dbo.PMX_PLLI ON dbo.PMX_PLHE.DocEntry = dbo.PMX_PLLI.DocEntry INNER JOIN
                      dbo.PMX_PLPL ON dbo.PMX_PLLI.BaseEntry = dbo.PMX_PLPL.DocEntry AND dbo.PMX_PLLI.BaseLine = dbo.PMX_PLPL.LineNum INNER JOIN
                      dbo.RDR1 ON dbo.PMX_PLPL.BaseEntry = dbo.RDR1.DocEntry AND dbo.PMX_PLPL.BaseLine = dbo.RDR1.LineNum AND 
                      dbo.PMX_PLPL.BaseType = dbo.RDR1.ObjType INNER JOIN
                      dbo.ORDR ON dbo.RDR1.DocEntry = dbo.ORDR.DocEntry INNER JOIN
                      dbo.OSHP ON dbo.ORDR.TrnspCode = dbo.OSHP.TrnspCode INNER JOIN
                      dbo.OITM ON dbo.PMX_PLLI.ItemCode = dbo.OITM.ItemCode INNER JOIN
                      dbo.PMX_OSEL AS PMX_OSEL_1 ON dbo.PMX_PLHE.DestStorLocCode = PMX_OSEL_1.Code LEFT OUTER JOIN
                      dbo.PMX_ITZT ON dbo.PMX_PLLI.ItemCode = dbo.PMX_ITZT.ItemCode LEFT OUTER JOIN
                      dbo.PMX_OSSL ON dbo.PMX_PLLI.StorLocCode = dbo.PMX_OSSL.Code LEFT OUTER JOIN
                      dbo.PMX_ITRI ON dbo.PMX_PLLI.ItemTransactionalInfoKey = dbo.PMX_ITRI.InternalKey LEFT OUTER JOIN
                      dbo.PMX_LUID ON dbo.PMX_PLLI.LogUnitIdentKey = dbo.PMX_LUID.InternalKey LEFT OUTER JOIN
					  dbo.PMX_SELD ON dbo.PMX_PLLI.DocEntry = dbo.PMX_SELD.baseEntry 
					  AND dbo.PMX_PLLI.LineNum = dbo.PMX_SELD.BaseLine
					   AND dbo.PMX_SELD.baseType = 'PMX_PLHE'  LEFT OUTER JOIN 
					   dbo.PMX_SENU ON PMX_SELD.SerialKey = dbo.PMX_SENU.InternalKey
	WHERE dbo.PMX_PLHE.DocEntry = @pickListDocEntry
	AND dbo.PMX_PLLI.LineStatus NOT IN ('C', 'F')
	ORDER BY Sequence
	
END